/*!
 * Ghostery for Firefox
 * http://www.ghostery.com/
 *
 * Copyright 2013 EVIDON, Inc. All rights reserved.
 * See ghostery_eula.txt for license.
 */

(function () {
//	console.log('ghostery\t' + document.location.href);


	// TODO slim down as much as possible

	var ALERT_ID = 'ghostery-alert-' + Math.ceil(Math.random() * 10000),
		ALERT_TIMER,
		CSS_INJECTED = false,
		UPGRADE_ALERT_SHOWN = false,
		FRAME_HAS_LOADED = false,
		FRAME_TIMER,
		SIDS = {},
		doc = document;

	function createEl(type) {
		return doc.createElement(type);
	}

	function br() {
		return createEl('br');
	}

	// arguments: parentElement, *childElements
	function appendChild(parent) {
		for (var i = 1; i < arguments.length; i++) {
			parent.appendChild(arguments[i]);
		}
	}

	function injectCSS() {
		var style = createEl('style'),
			imp = ' !important;';

		style.innerHTML = '#' + ALERT_ID + '{' +
			'border:solid 2px #ffffff' + imp +
			'box-sizing:content-box' + imp +
			'display:block' + imp +
			'margin:0' + imp +
			'opacity:0.9' + imp +
			'padding:0' + imp +
			'position:fixed' + imp +
			'scrolling:no' + imp +
			'seamless:seamless' + imp +
			'visibility:visible' + imp +
			'z-index:2147483647' + imp +

			'-moz-border-radius:5px' + imp +
			'border-radius:5px' + imp +

			'box-shadow:0px 0px 20px #000000' + imp +
			'-moz-box-shadow:0px 0px 20px #000000' + imp +
			'text-transform: none' + imp +

			'box-sizing:content-box' + imp +
			'-moz-box-sizing:content-box' + imp +

			'}' +
			'@media print, screen and (view-mode:minimized){#' + ALERT_ID + '{display:none' + imp + '}}';

		appendChild(doc.getElementsByTagName('head')[0], style);
	}

	function removeAlert() {
		var el = doc.getElementById(ALERT_ID);
		
		if (el) {
			FRAME_HAS_LOADED = false;
			window.clearTimeout(FRAME_TIMER);
			el.parentNode.removeChild(el);
		}
		window.clearTimeout(ALERT_TIMER);
	}

	function createAlertLink(href, text) {
		var link = createEl('a');
		link.style.color = '#ffffff';
		link.style.textDecoration = 'underline';
		link.style.border = 'none';
		link.href = href || '#';
		if (href) {
			link.target = '_blank';
		}
		appendChild(link, doc.createTextNode(text));
		return link;
	}

	function span(text, class_name) {
		var s = createEl('span');
		if (class_name) {
			s.className = class_name;
		}
		appendChild(s, doc.createTextNode(text));
		return s;
	}

	function createAlert(type, alert_cfg) {
		var alert_iframe = createEl('iframe');

		alert_iframe.id = ALERT_ID;
		alert_iframe.src = 'data:;charset=utf-8,';
		
		alert_iframe.style.setProperty(
				'visibility',
				'hidden',
				'important');
		alert_iframe.style.setProperty(
			(alert_cfg && alert_cfg.pos_x == 'left' ? 'left' : 'right'),
			'20px',
			'important');
		alert_iframe.style.setProperty(
			(alert_cfg && alert_cfg.pos_y == 'bottom' ? 'bottom' : 'top'),
			'15px',
			'important');

		alert_iframe.style.setProperty(
			'background',
			(type == 'showBugs' ? '#330033' : '#777777'),
			'important');

		if (doc.getElementsByTagName('body')[0]) {
			appendChild(doc.body, alert_iframe);
		} else {
			appendChild(doc.getElementsByTagName('html')[0], alert_iframe);
		}

		alert_iframe.contentWindow.addEventListener('DOMContentLoaded', function () {
			var iframe_doc = alert_iframe.contentDocument,
				iframe_style = iframe_doc.createElement('style');
			
			iframe_style.innerHTML = 'body{' +
				'color:#ffffff;' +
				'font:13px Arial,Helvetica;' +
				'margin:0;' +
				'padding:7px 10px;' +
				'white-space:nowrap;' +
				'}' +
				'.blocked{color:#777777;text-decoration:line-through;}';
			appendChild(iframe_doc.getElementsByTagName('head')[0], iframe_style);
	
			if (type == 'showBugs') {
				iframe_doc.body.style.cursor = 'pointer';
				iframe_doc.body.removeEventListener('click', removeAlertOnClick);
				iframe_doc.body.addEventListener('click', removeAlertOnClick);
			}
			
			FRAME_HAS_LOADED = true;
		});
		
		return alert_iframe;
	}

	function removeAlertOnClick(e) {
		removeAlert();
		e.preventDefault();
	}

	function showAlert(type, bugs, alert_cfg) {
		// only tear down the frame for upgrade notifications/walkthrough reminders
		if (type != 'showBugs') {
			removeAlert();
		}

		var alert_iframe,
			alert_frag = doc.createDocumentFragment(),
			link;

		if (type == 'showBugs') {
			for (var i = 0; i < bugs.length; i++) {
				appendChild(alert_frag, span(
					bugs[i].name + (bugs[i].userCreated ? ' (U)' : ''),
					(bugs[i].blocked ? 'blocked' : '')
				), br());
			}

		} else {
			if (type != 'showUpdateAlert') {
				appendChild(alert_frag, createAlertLink(
					'http://purplebox.ghostery.com/?cat=82',
					window.l10n.notification_upgrade
				));
			}

			if (type == 'showWalkthroughAlert' || type == 'showUpdateAlert') {
				if (type == 'showUpdateAlert') {
					appendChild(alert_frag, span(window.l10n.notification_update));
					link = createAlertLink('', window.l10n.notification_update_link);

				} else {
					appendChild(alert_frag,
						br(),
						br(),
						span(window.l10n.notification_reminder1),
						br(),
						span(window.l10n.notification_reminder2)
					);
					link = createAlertLink('', window.l10n.notification_reminder_link);
				}

				link.addEventListener('click', function (e) {
					var msg = (type == 'showUpdateAlert' ? 'showNewTrackers' : 'openWalkthrough');
					self.port.emit(msg, {msg: msg});
					e.preventDefault();
				});
				appendChild(alert_frag, br(), br(), link);
			}

			link = createAlertLink(false, window.l10n.dismiss);
			link.addEventListener('click', function (e) {
				removeAlert();
				e.preventDefault();
			});
			appendChild(alert_frag, br(), br(), link);
		}

		alert_iframe = doc.getElementById(ALERT_ID);

		if (!alert_iframe) {
			alert_iframe = createAlert(type, alert_cfg);
		}
		
		function waitForFrameLoad(alert_iframe, alert_frag) {
			var iframe_body = alert_iframe.contentDocument.body;
			iframe_body.innerHTML = '';
			appendChild(iframe_body, alert_frag);
			
			// resize the iframe
			alert_iframe.style.setProperty('visibility', 'visible', 'important');
			alert_iframe.style.setProperty('height', '0px', 'important');
			alert_iframe.style.setProperty('width', '0px', 'important');
			alert_iframe.style.setProperty('height', iframe_body.scrollHeight + 'px', 'important');
			alert_iframe.style.setProperty('width', (iframe_body.scrollWidth + 10) + 'px', 'important'); // 10 added to fix display issue on right side: scrollWidth not including right-padding

			// restart the close alert bubble timer
			window.clearTimeout(ALERT_TIMER);
			if (alert_cfg && alert_cfg.timeout) {
				ALERT_TIMER = window.setTimeout(removeAlert, alert_cfg.timeout * 1000);
			}
		}
		
		if (!FRAME_HAS_LOADED) {
			window.clearTimeout(FRAME_TIMER);
			FRAME_TIMER = window.setTimeout(waitForFrameLoad, 500, alert_iframe, alert_frag);
		} else {
			window.clearTimeout(FRAME_TIMER);
			waitForFrameLoad(alert_iframe, alert_frag);
		}
	}

	self.port.on('show', function (msg) {
//		console.log('RECEIVED\t' + msg.msg);
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		if (!UPGRADE_ALERT_SHOWN) {
			showAlert('showBugs', msg.bugs, msg.alert_cfg);
		}
	});
	self.port.on('showUpgradeAlert', function (msg) {
//		console.log('RECEIVED\t' + msg.msg);
		window.l10n = msg.l10n;
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		showAlert(msg.msg);
		UPGRADE_ALERT_SHOWN = true;
	});
	self.port.on('showWalkthroughAlert', function (msg) {
//		console.log('RECEIVED\t' + msg.msg);
		window.l10n = msg.l10n;
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		showAlert(msg.msg);
		UPGRADE_ALERT_SHOWN = true;
	});
	self.port.on('showUpdateAlert', function (msg) {
//		console.log('RECEIVED\t' + msg.msg);
		window.l10n = msg.l10n;
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		showAlert(msg.msg);
		UPGRADE_ALERT_SHOWN = true;
	});
	self.port.on('surrogates', function (msg) {
//		console.log('RECEIVED\t' + msg.msg);
		var code = '';

		// don't surrogate the same sid multiple times
		msg.surrogates.forEach(function (s) {
			if (!SIDS.hasOwnProperty(s.sid)) {
				code += s.code;
				SIDS[s.sid] = true;
			}
		});

		if (code) {
			var script = createEl('script');
			appendChild(script, doc.createTextNode(code));
			doc.documentElement.insertBefore(script, doc.documentElement.firstChild);
		}
	});
}());